"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AIStream = void 0;
var react_1 = __importStar(require("react"));
var lodash_1 = require("lodash");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var react_2 = require("react");
var use_sse_1 = require("primeobjects-ui-web-basic/build/cjs/hooks/use-sse");
var index_1 = __importDefault(require("react-autosize-textarea/lib/index"));
var auth_cognito_1 = require("../context/auth-cognito");
var solution_1 = require("primeobjects-helper-ui/build/cjs/hooks/solution");
var auth_call_api_1 = require("../context/auth-call-api");
var AIStream = function (props) {
    var _a, _b, _c;
    var style = props.style, placeholder = props.placeholder, disabled = props.disabled, rows = props.rows, maxRows = props.maxRows, request = props.request;
    var className = (_a = props.className) !== null && _a !== void 0 ? _a : "";
    var textRef = (0, react_2.useRef)("");
    var _d = (0, react_2.useState)(undefined), streaming = _d[0], setStreaming = _d[1];
    var _e = (0, react_2.useState)(""), value = _e[0], setValue = _e[1];
    var start = (_b = props.start) !== null && _b !== void 0 ? _b : request === null || request === void 0 ? void 0 : request.start;
    var apiType = (_c = request === null || request === void 0 ? void 0 : request.apiType) !== null && _c !== void 0 ? _c : "prompt";
    var solution = (0, solution_1.useSolution)();
    var appendValue = function (v) {
        console.log(v);
        onChange(textRef.current + v);
    };
    var resetValue = function () {
        onChange("");
    };
    var onError = function (error) {
        console.error(error);
        setStreaming(undefined);
        props.onError && props.onError(error);
    };
    var openStream = (0, use_sse_1.useServerSentEvents)({
        baseUrl: "/api/ai-stream",
        config: {
            withCredentials: false
        },
        onData: function (data) {
            var _a;
            console.log({ data: data });
            if ((0, primeobjects_helper_util_1.libTrackIsOn)())
                console.log({ onData: data });
            try {
                var text = (_a = JSON.parse(data).choices[0].text) !== null && _a !== void 0 ? _a : JSON.parse(data).choices[0].delta.content;
                if ((0, primeobjects_helper_util_1.isNonEmptyString)(text) &&
                    ((textRef.current.length == 0 && text != "\n") ||
                        textRef.current.length > 0)) {
                    appendValue(text);
                }
                props.onData && props.onData(text);
            }
            catch (err) {
                console.log("Failed to parse data: ".concat(data));
            }
        },
        onOpen: function () {
            if ((0, primeobjects_helper_util_1.libTrackIsOn)())
                console.log("onOpen");
            props.onStart && props.onStart();
            if (textRef.current) {
                textRef.current = "";
            }
        },
        onClose: function () {
            if ((0, primeobjects_helper_util_1.libTrackIsOn)())
                console.log("onClose");
            onFinish();
        },
        onError: function (event) {
            onError(event);
        }
    }).openStream;
    var onChange = function (value) {
        textRef.current = value;
        setValue(value);
        props.onChange && props.onChange(value);
    };
    var runStream = function (auth) {
        //because the stream request will fail if there is large content in the assistant
        //we create an S3 file first by calling submit-assistant-stream API, it contains assistant and OpenAI data
        //the stream will get detail from s3 file by calling start-assistant-stream
        (0, auth_call_api_1.callApi)(solution, 
        //`${solution.apis[apiType]}submit-stream`,
        "http://localhost:3000/prod/submit-stream", {
            request: request
        }, "POST")
            .then(function (result) {
            openStream({
                query: {
                    auth: auth,
                    transactionId: result.transactionId,
                    apiType: apiType
                }
            });
        })
            .catch(function (error) {
            onError(error);
        });
    };
    var onFinish = function () {
        var _a, _b, _c;
        setStreaming(undefined);
        var result = "".concat(textRef.current);
        props.onFinish && props.onFinish("".concat(textRef.current));
        var maxTokens = (_a = request === null || request === void 0 ? void 0 : request.maxTokens) !== null && _a !== void 0 ? _a : 0;
        var commandTokens = ("".concat((_b = request === null || request === void 0 ? void 0 : request.template) !== null && _b !== void 0 ? _b : "").length +
            JSON.stringify((_c = request === null || request === void 0 ? void 0 : request.parameters) !== null && _c !== void 0 ? _c : {}).length) /
            4;
        var estimatedTokens = commandTokens + maxTokens;
        var realTokens = commandTokens + result.length / 4;
        console.log({
            estimatedTokens: estimatedTokens,
            request: request,
            commandTokens: commandTokens,
            r: result.length
        });
        (0, auth_call_api_1.callApi)(solution, 
        //`${solution.apis[apiType]}finish-stream`,
        "http://localhost:3000/prod/finish-stream", {
            model: request === null || request === void 0 ? void 0 : request.model,
            transactionId: request === null || request === void 0 ? void 0 : request.transactionId,
            tokens: realTokens - estimatedTokens
        }, "POST");
    };
    (0, react_1.useEffect)(function () {
        if (!(0, lodash_1.isNil)(start) && start != streaming) {
            resetValue();
            setStreaming(start);
            (0, auth_cognito_1.getCurrentPoolUser)(props.solution ? props.solution : solution).then(function (cognito) {
                if (cognito) {
                    var authorization = cognito.signInUserSession.idToken.jwtToken;
                    var accessToken = cognito.signInUserSession.accessToken.jwtToken;
                    var auth = { authorization: authorization, accessToken: accessToken };
                    runStream(JSON.stringify(auth));
                }
            });
        }
    }, [start]);
    return (react_1.default.createElement(index_1.default, { value: value, style: style, rows: rows, maxRows: maxRows, disabled: disabled, className: className, placeholder: placeholder, onChange: function (e) {
            if (textRef.current != e.target.value) {
                onChange(e.target.value);
            }
        } }));
};
exports.AIStream = AIStream;
exports.default = exports.AIStream;
//# sourceMappingURL=ai-stream.js.map