"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SitePageSection = exports.SitePageHeroArea = void 0;
var react_1 = __importStar(require("react"));
var site_section_1 = __importDefault(require("./site-section"));
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var lodash_1 = require("lodash");
var site_similar_1 = __importDefault(require("./site-similar"));
var site_tags_1 = __importDefault(require("./site-tags"));
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
var primeobjects_ui_web_basic_1 = require("primeobjects-ui-web-basic");
var react_2 = require("react");
var site_swiper_1 = __importDefault(require("./site-swiper"));
var SitePageHeroArea = function (props) {
    var content = props.content, media = props.media, className = props.className;
    var width = props.width && props.width > 0 ? props.width : 0;
    //16:9 "56.25%"
    //4:3 "75%"
    //3:2 "66%"
    return (react_1.default.createElement("div", { className: "w-full pb-8 ".concat(className ? className : ""), style: { width: "".concat(width, "%") } },
        (0, primeobjects_helper_util_1.isNonEmptyString)(media) && (react_1.default.createElement("div", { className: "w-full bg-center bg-cover img", style: {
                backgroundImage: "url(".concat(media, ")"),
                height: 0,
                paddingTop: "66%"
            } })),
        content && (react_1.default.createElement("div", { className: "w-full", dangerouslySetInnerHTML: { __html: content } }))));
};
exports.SitePageHeroArea = SitePageHeroArea;
var SitePageSection = function (props) {
    var solution = props.solution, page = props.page, tagSectionTitle = props.tagSectionTitle, flushCache = props.flushCache, urlTemplate = props.urlTemplate, similarSectionTitle = props.similarSectionTitle, similarSectionAdditionalData = props.similarSectionAdditionalData;
    var colorName = (0, primeobjects_helper_ui_1.usePrimaryColorName)(solution);
    var pageContent = page === null || page === void 0 ? void 0 : page.content;
    var main = pageContent === null || pageContent === void 0 ? void 0 : pageContent.main;
    var leftAreaWidth = main.leftAreaWidthControl &&
        (0, lodash_1.isNumber)(main.leftAreaWidth) &&
        main.leftAreaWidth > 0
        ? main.leftAreaWidth
        : 0;
    var rightAreaWidth = main.rightAreaWidthControl &&
        (0, lodash_1.isNumber)(main.rightAreaWidth) &&
        main.rightAreaWidth > 0
        ? main.rightAreaWidth
        : 0;
    var maxTagCount = props.maxTagCount ? props.maxTagCount : 100;
    var tags = (0, lodash_1.isArray)(page.tags) ? page.tags.slice(0, maxTagCount) : [];
    var _a = (0, react_2.useState)({
        flexDirection: "row"
    }), mainAreaStyle = _a[0], setMainAreaStyle = _a[1];
    var _b = (0, react_2.useState)(50), curLeftAreaWidth = _b[0], setCurLeftAreaWidth = _b[1];
    (0, react_1.useEffect)(function () {
        if (leftAreaWidth == 0 && rightAreaWidth == 0)
            setCurLeftAreaWidth(50);
        if (leftAreaWidth > 0)
            setCurLeftAreaWidth(leftAreaWidth);
        if (rightAreaWidth > 0)
            setCurLeftAreaWidth(100 - rightAreaWidth);
    }, [leftAreaWidth, rightAreaWidth]);
    var onResizeMainArea = function (width) {
        if (width &&
            (width < 650 ||
                width - (curLeftAreaWidth * width) / 100.0 < 300 ||
                (curLeftAreaWidth * width) / 100.0 < 300)) {
            setMainAreaStyle({ flexDirection: "column" });
        }
        else {
            if (leftAreaWidth > 0 || rightAreaWidth > 0) {
                setMainAreaStyle({ flexDirection: "row" });
            }
            else {
                setMainAreaStyle({});
            }
        }
    };
    return (react_1.default.createElement(site_section_1.default, { className: "relative" },
        react_1.default.createElement("div", { className: "w-full max-w-7xl mx-auto" },
            react_1.default.createElement("div", { className: "flex flex-col lg:flex-row relative w-full" },
                react_1.default.createElement("div", { className: "w-full lg:max-w-4xl inline article  mx-auto" },
                    react_1.default.createElement(primeobjects_ui_web_basic_1.ResizeDetectorDiv, { className: "flex w-full", onDetect: onResizeMainArea, style: mainAreaStyle },
                        main && (react_1.default.createElement(exports.SitePageHeroArea, { media: main.leftAreaMedia, content: main.leftAreaContent, width: mainAreaStyle.flexDirection == "column"
                                ? 100
                                : curLeftAreaWidth, className: "pr-8" })),
                        main && (react_1.default.createElement(exports.SitePageHeroArea, { media: main.rightAreaMedia, content: main.rightAreaContent, width: mainAreaStyle.flexDirection == "column"
                                ? 100
                                : 100 - curLeftAreaWidth }))),
                    (0, lodash_1.map)([1, 2, 3, 4, 5], function (i) {
                        return pageContent &&
                            pageContent["sectionCategoryId_".concat(i)] ? (react_1.default.createElement(site_swiper_1.default, { solution: solution, key: i, flushCache: flushCache, cacheKey: "page-swiper", feedType: "categories", feedValue: pageContent["sectionCategoryId_".concat(i)], scope: "global-and-organization", globalOrganizationId: page.organizationId, urlTemplate: urlTemplate, title: pageContent["sectionTitle_".concat(i)], titleSize: "h3" })) : (react_1.default.createElement(react_1.default.Fragment, { key: i }));
                    }),
                    react_1.default.createElement(site_tags_1.default, { data: tags, colorName: colorName, disableShorten: true, wrapperClassName: "xl:hidden mt-6", tagClassName: "mr-4 mb-4 hover:bg-".concat(colorName, "-100"), tagBorderClassName: "border-gray-100 shadow", title: tagSectionTitle, titleSize: "h3" })),
                react_1.default.createElement("div", { className: "hidden flex-1 mt-10 xl:flex xl:flex-col lg:border-l lg:pl-10 lg:ml-10 lg:mt-0" },
                    react_1.default.createElement(site_tags_1.default, { data: tags, colorName: colorName, disableShorten: true, tagClassName: "mr-4 mb-4 hover:bg-".concat(colorName, "-100"), tagBorderClassName: "border-gray-100 shadow", titleClassName: "xl:hidden", title: tagSectionTitle, titleSize: "h3" }),
                    react_1.default.createElement(site_similar_1.default, { solution: solution, flushCache: flushCache, cacheKey: "page-similar", feedType: "id", feedValue: page.id, scope: "global-and-organization", globalOrganizationId: page.organizationId, additionalData: similarSectionAdditionalData, urlTemplate: urlTemplate, title: similarSectionTitle, titleSize: "h3" }))))));
};
exports.SitePageSection = SitePageSection;
exports.default = exports.SitePageSection;
//# sourceMappingURL=site-page.js.map