"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteSimilarSection = void 0;
var react_1 = __importStar(require("react"));
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var site_title_1 = __importDefault(require("./site-title"));
var util_1 = require("../util");
var record_1 = require("primeobjects-helper-util/build/cjs/record");
var lodash_1 = require("lodash");
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
var lottie_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/lottie"));
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var other_1 = require("primeobjects-ui-web-basic/build/cjs/util/other");
var SiteSimilarSection = function (props) {
    var solution = props.solution, feedValue = props.feedValue, feedType = props.feedType, title = props.title, subTitle = props.subTitle, titleSize = props.titleSize, subTitleSize = props.subTitleSize, pageNumber = props.pageNumber, urlTemplate = props.urlTemplate, globalOrganizationId = props.globalOrganizationId, scope = props.scope, flushCache = props.flushCache;
    var _a = (0, react_1.useState)(true), loading = _a[0], setLoading = _a[1];
    var _b = (0, react_1.useState)(null), result = _b[0], setResult = _b[1];
    var SSR = (0, core_1.isSSR)();
    var wrapperClassName = (0, core_1.isNonEmptyString)(props.wrapperClassName)
        ? props.wrapperClassName
        : "";
    var listClassName = (0, core_1.isNonEmptyString)(props.listClassName)
        ? props.listClassName
        : "";
    var itemTitleClassName = (0, core_1.isNonEmptyString)(props.itemTitleClassName)
        ? props.itemTitleClassName
        : "";
    var entityName = props.entityName ? props.entityName : "Card";
    var pageSize = (0, lodash_1.isNumber)(props.pageSize) && props.pageSize > 0 ? props.pageSize : 5;
    var _c = (0, react_1.useState)([]), data = _c[0], setData = _c[1];
    var primaryColor = (0, primeobjects_helper_ui_1.getPrimaryColor)(solution);
    var fullRecord = false;
    var cacheKey = props.cacheKey
        ? "".concat(props.cacheKey, "-").concat(feedType, "-").concat(feedValue, "-").concat(scope, "-").concat(fullRecord)
        : undefined;
    (0, react_1.useEffect)(function () {
        var newData = (result === null || result === void 0 ? void 0 : result.data) ? result === null || result === void 0 ? void 0 : result.data : [];
        var additionalData = props.additionalData ? props.additionalData : [];
        for (var i = 0; i < additionalData.length && newData.length < 5; i++) {
            newData.push(additionalData[i]);
        }
        setData((0, lodash_1.uniqBy)(newData, function (d) { return d.id; }));
        setLoading(false);
    }, [result, props.additionalData]);
    (0, react_1.useEffect)(function () {
        if (solution.id && !SSR) {
            (0, util_1.callApiBase)((0, util_1.getApiEndpoint)(solution, "recommendation", "similar-by-content"), __assign(__assign({}, (feedType == "id"
                ? {
                    id: feedValue
                }
                : {
                    content: feedValue
                })), { fullRecord: fullRecord, scope: scope, globalOrganizationId: globalOrganizationId, entityName: entityName, pageSize: pageSize, pageNumber: pageNumber, cacheKey: cacheKey, flushCache: flushCache, cacheExpireMinutes: 60 * 24 * 365 }), "POST", { solutionId: solution.id }).then(function (result) {
                setResult(result);
            });
        }
    }, [SSR, solution.id]);
    return (react_1.default.createElement("div", { className: "w-full ".concat(wrapperClassName) },
        react_1.default.createElement(site_title_1.default, { title: title, subTitle: subTitle, titleSize: titleSize, subTitleSize: subTitleSize, titleClassName: "text-left text-".concat(primaryColor.name, "-600"), subTitleClassName: "text-left" }),
        loading ? (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement("div", { className: "w-full flex flex-row items-center" },
                react_1.default.createElement("div", { className: "h-10" },
                    react_1.default.createElement(lottie_1.default, { className: "w-full h-full", url: "/icons/platform/lottie/dots-2.json", colors: Array(6).fill(primeobjects_helper_util_1.COLORS.GRAY[600]) })),
                react_1.default.createElement("div", { className: "flex-1 text-base text-gray-600 p-2" }, "Loading ...")))) : (react_1.default.createElement("div", { className: "flex flex-col pt-2 ".concat(listClassName) }, (0, lodash_1.without)((0, lodash_1.map)(data, function (record, i) {
            var title = record.title
                ? record.title
                : record.display;
            record.abstract = (0, other_1.convertHtmlToText)(record.abstract, "abstract");
            var desc = (0, record_1.getRecordAbstract)(record, 128, true);
            return record.stateCode < 0 ? null : (react_1.default.createElement("div", { className: "py-2", key: i },
                react_1.default.createElement("a", { href: urlTemplate
                        .replace(/\[PH.SLUG\]/g, record.slug)
                        .replace(/\[PH.ID\]/g, record.id), className: "flex flex-col mb-5 text-gray-900 ".concat(itemTitleClassName), style: {
                        textDecoration: "none"
                    } },
                    react_1.default.createElement("span", { className: "font-semibold text-lg line-clamp-3 ".concat((0, core_1.isNonEmptyString)(desc)
                            ? "mb-3"
                            : "mb-0") }, title),
                    react_1.default.createElement("p", { className: "text-base text-gray-500 line-clamp-3", style: { paddingBottom: 0 } }, desc))));
        }), null)))));
};
exports.SiteSimilarSection = SiteSimilarSection;
exports.default = exports.SiteSimilarSection;
//# sourceMappingURL=site-similar.js.map