//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React from "react";
import { isFunction, map, without, isNil, isNumber } from "lodash";
import { getRecordDisplay, isNonEmptyString, COLORS, getColor, doNothing } from "primeobjects-helper-util";
import { SVG, Tags } from "primeobjects-ui-web-basic";
import Tooltip from "../../controls/antd/tooltip";
import Dropdown from "../../controls/antd/dropdown";
import Popconfirm from "../../controls/antd/popconfirm";
import Menu from "../../controls/antd/menu";
import { getPrimaryColor } from "primeobjects-helper-ui/build/cjs/hooks/primary-color";
export var renderTitleCell = function (props) {
    var entity = props.entity;
    var getAlignmentClass = function () {
        switch (props.alignment) {
            case "center":
                return "self-center";
            case "right":
                return "self-end";
            default:
                return "self-start";
        }
    };
    var fn = function (cellProps) {
        var _a, _b, _c, _d;
        return (React.createElement("div", { className: "w-full h-full flex flex-col ".concat((_a = props.wrapperClassName) !== null && _a !== void 0 ? _a : ""), style: (_b = props.wrapperStyle) !== null && _b !== void 0 ? _b : {} },
            React.createElement("div", { className: "h-full flex ".concat(getAlignmentClass(), " items-center ").concat((_c = props.className) !== null && _c !== void 0 ? _c : ""), style: (_d = props.style) !== null && _d !== void 0 ? _d : {} }, isFunction(props.content)
                ? props.content(__assign(__assign({}, cellProps), { entity: entity }))
                : props.content)));
    };
    return fn;
};
export var renderBodyCell = function (props) {
    var entity = props.entity;
    var getAlignmentClass = function () {
        switch (props.alignment) {
            case "center":
                return "self-center";
            case "right":
                return "self-end";
            default:
                return "self-start";
        }
    };
    var renderSelectIndicator = function () {
        if (!props.rowSelected)
            return null;
        var primaryColor = getPrimaryColor();
        return (React.createElement("div", { className: "rounded-md absolute w-1 ml-1.5 left bg-".concat(primaryColor, "-400"), style: {
                height: "calc(100% - 32px)",
                left: 0
            } }));
    };
    var fn = function (v, record) {
        var _a, _b, _c, _d;
        return (React.createElement("div", { className: "w-full h-full flex flex-col p-0 ".concat((_a = props.wrapperClassName) !== null && _a !== void 0 ? _a : ""), style: (_b = props.wrapperStyle) !== null && _b !== void 0 ? _b : {} },
            renderSelectIndicator(),
            React.createElement("div", { className: "h-full w-full flex ".concat(getAlignmentClass(), " items-center ").concat((_c = props.className) !== null && _c !== void 0 ? _c : ""), style: (_d = props.style) !== null && _d !== void 0 ? _d : {} }, isFunction(props.content)
                ? props.content(v, record, entity)
                : props.content)));
    };
    return fn;
};
export var getDefaultFirstBodyCell = function (onClickRecord, entity, settings) {
    var _a;
    var primaryColor = getPrimaryColor();
    return {
        title: (settings === null || settings === void 0 ? void 0 : settings.title) ? settings.title : "",
        dataIndex: "display",
        id: "display",
        key: "default-display",
        className: "".concat((_a = settings === null || settings === void 0 ? void 0 : settings.className) !== null && _a !== void 0 ? _a : "padding-0-cell", " ").concat((settings === null || settings === void 0 ? void 0 : settings.onClick) ? "clickable-cell" : ""),
        render: renderBodyCell({
            isFirstColumn: true,
            entity: entity,
            className: "text-sm leading-tight font-medium text-gray-900",
            content: function (v, record) {
                var curRecord = (settings === null || settings === void 0 ? void 0 : settings.getCurrentRecord) && (settings === null || settings === void 0 ? void 0 : settings.getCurrentRecord());
                doNothing(v);
                return (React.createElement(React.Fragment, null,
                    record && (curRecord === null || curRecord === void 0 ? void 0 : curRecord.id) == record.id && (React.createElement("div", { className: "bg-".concat(primaryColor.name, "-400 absolute top-0 left-0 w-1"), style: {
                            height: "calc(100% - 2px)",
                            margin: 1
                        } })),
                    record &&
                        renderListRecordInAction(record, entity, settings),
                    record &&
                        renderListDefaultColumn(record, entity, __assign(__assign({}, settings), { actionName: (settings === null || settings === void 0 ? void 0 : settings.actionName)
                                ? settings.actionName
                                : "display", onClick: onClickRecord }))));
            }
        })
    };
};
export var renderListActionButtonColumn = function (menuItems, onClick, entity, settings) {
    var onValidMenuItem = settings === null || settings === void 0 ? void 0 : settings.onValidMenuItem;
    var onClickDiv = function (e) {
        var _a, _b, _c;
        if (isNonEmptyString((_a = e.target) === null || _a === void 0 ? void 0 : _a.className) &&
            ((_c = (_b = e.target) === null || _b === void 0 ? void 0 : _b.className) === null || _c === void 0 ? void 0 : _c.indexOf("action-button-wrapper")) >= 0) {
            e.target
                .getElementsByClassName("action-button-dropdown")[0]
                .click();
        }
    };
    return {
        title: "",
        id: "id",
        dataIndex: "id",
        key: "action-button",
        width: 40,
        fixed: settings === null || settings === void 0 ? void 0 : settings.fixed,
        className: "clickable-cell",
        render: function (id, record, rowIndex) {
            var r = __assign({ id: id }, record);
            var currentMenuItems = without(map(menuItems, function (menuItem, index) {
                var isValid = !onValidMenuItem ||
                    (onValidMenuItem && onValidMenuItem(menuItem, record));
                return isValid ? (React.createElement(Menu.Item, { key: "action-button-menu-".concat(index), className: "w-full", onClick: function () {
                        isNil(menuItem.confirmationTitle) &&
                            onClick &&
                            onClick(r, menuItem.action, entity, rowIndex);
                    } }, !isNil(menuItem.confirmationTitle) ? (React.createElement(Popconfirm, { placement: "left", okType: menuItem.confirmationType, title: menuItem.confirmationTitle, onConfirm: function () {
                        onClick &&
                            onClick(r, menuItem.action, entity, rowIndex);
                    }, okText: "Yes", cancelText: "No" }, menuItem.title)) : (React.createElement("span", null, menuItem.title)))) : null;
            }), null);
            var menu = currentMenuItems.length > 0 && (React.createElement(Menu, null, currentMenuItems));
            var wrapperClassName = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderWrapperClassName)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderWrapperClassName(record)
                : "";
            var wrapperStyle = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderWrapperStyle)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderWrapperStyle(record)
                : {};
            var cellClassName = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderCellClassName)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderCellClassName(record)
                : "";
            var cellStyle = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderCellStyle)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderCellStyle(record)
                : {};
            var iconClassName = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderIconClassName)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderIconClassName(record)
                : {};
            var iconColor = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderIconColor)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderIconColor(record)
                : "#000000";
            var icon = (settings === null || settings === void 0 ? void 0 : settings.onGetIconUrl)
                ? settings === null || settings === void 0 ? void 0 : settings.onGetIconUrl(record)
                : record.uiDoing
                    ? "/icons/platform/loading.svg"
                    : "/icons/platform/menu-vertical.svg";
            return menu ? (React.createElement("div", { className: "action-button-wrapper w-full h-full flex justify-center flex-col p-0 ".concat(record.uiDisabled
                    ? "cursor-not-allowed"
                    : "cursor-pointer", " ").concat(cellClassName), style: cellStyle, onClick: onClickDiv },
                React.createElement(Dropdown, { disabled: record.uiDisabled, trigger: ["click"], overlay: menu, placement: "bottomLeft" },
                    React.createElement("div", { className: "action-button-dropdown w-full flex justify-center ".concat(wrapperClassName), style: wrapperStyle },
                        React.createElement(SVG, { id: "action-button-svg list-col-icon-action-button", color: iconColor, src: icon, className: "h-4 w-4 ".concat(record.uiDoing ? "spinner" : "", " ").concat(iconClassName) }))))) : (React.createElement(React.Fragment, null));
        }
    };
};
export var renderListIconButtonColumn = function (iconUrl, action, onClick, entity, settings) {
    var _a;
    // const context = settings?.context;
    var key = "icon-col-".concat(action);
    var id = iconUrl
        ? iconUrl.split("/")[iconUrl.split("/").length - 1]
        : key;
    return {
        title: (_a = settings === null || settings === void 0 ? void 0 : settings.title) !== null && _a !== void 0 ? _a : "",
        id: id,
        dataIndex: "id",
        key: key,
        width: isNumber(settings === null || settings === void 0 ? void 0 : settings.width) ? settings === null || settings === void 0 ? void 0 : settings.width : 40,
        fixed: settings === null || settings === void 0 ? void 0 : settings.fixed,
        className: "clickable-cell",
        render: function (id, record, rowIndex) {
            var r = __assign({ id: id }, record);
            var wrapperClassName = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderWrapperClassName)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderWrapperClassName(r)
                : "";
            var wrapperStyle = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderWrapperStyle)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderWrapperStyle(r)
                : {};
            var cellClassName = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderCellClassName)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderCellClassName(record)
                : "";
            var cellStyle = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderCellStyle)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderCellStyle(record)
                : {};
            var iconClassName = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderIconClassName)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderIconClassName(r)
                : "";
            var iconColor = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderIconColor)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderIconColor(r)
                : COLORS.BLACK;
            var textClassName = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderTextClassName)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderTextClassName(r)
                : "";
            var textStyle = isFunction(settings === null || settings === void 0 ? void 0 : settings.onRenderTextStyle)
                ? settings === null || settings === void 0 ? void 0 : settings.onRenderTextStyle(r)
                : {};
            var icon = (settings === null || settings === void 0 ? void 0 : settings.onGetIconUrl)
                ? settings === null || settings === void 0 ? void 0 : settings.onGetIconUrl(record)
                : iconUrl;
            var text = (settings === null || settings === void 0 ? void 0 : settings.onGetText)
                ? settings === null || settings === void 0 ? void 0 : settings.onGetText(record)
                : settings === null || settings === void 0 ? void 0 : settings.text;
            var tooltip = (settings === null || settings === void 0 ? void 0 : settings.onGetTooltip)
                ? settings === null || settings === void 0 ? void 0 : settings.onGetTooltip(record)
                : settings === null || settings === void 0 ? void 0 : settings.tooltip;
            var c = (React.createElement("div", { className: "w-full flex justify-center items-center ".concat(wrapperClassName), style: wrapperStyle },
                icon && icon.endsWith(".svg") && (React.createElement(SVG, { id: "list-col-icon", color: iconColor, src: icon, className: "h-4 w-4 ".concat(iconClassName) })),
                icon && !icon.endsWith(".svg") && (React.createElement("img", { id: "list-col-icon", src: icon, className: "h-4 w-4 ".concat(iconClassName) })),
                isNonEmptyString(text) && (React.createElement("span", { className: "ml-1 ".concat(textClassName), style: textStyle }, text))));
            var onClickCell = function (record, action, entity, rowIndex) {
                var newAction = (settings === null || settings === void 0 ? void 0 : settings.onGetActionName)
                    ? settings === null || settings === void 0 ? void 0 : settings.onGetActionName(record)
                    : action;
                onClick && onClick(r, newAction, entity, rowIndex);
            };
            return (React.createElement("div", { className: "w-full h-full flex justify-center flex-col p-0 ".concat(record.uiDisabled
                    ? "cursor-not-allowed"
                    : onClick
                        ? "cursor-pointer"
                        : "", " ").concat(cellClassName), style: cellStyle, onClick: function () {
                    !record.uiDisabled &&
                        onClickCell(r, action, entity, rowIndex);
                } }, tooltip ? (React.createElement(Tooltip, { color: tooltip.color ? tooltip.color : "#999999", placement: tooltip.placement ? tooltip.placement : "left", title: tooltip.title }, c)) : (c)));
        }
    };
};
export var DEFAULT_LIST_SELECT_COLUMN = function (onClick, entity, settings) {
    // const recordInAction = settings?.recordInAction;
    // const primaryColor = getPrimaryColor();
    // const color = primaryColor["500"];
    // const newSettings: TListColumnSettings = {
    //     ...(settings ? settings : {}),
    //     onRenderIconColor: (currentRecord?: Record<string, any>) => {
    //         return recordInAction?.color ? color : "#EFEFEF";
    //     }
    // };
    return renderListIconButtonColumn("/icons/platform/bold-arrow-right-filled.svg", "read", isFunction(onClick) ? onClick : function () { }, entity, settings);
};
export var DEFAULT_LIST_PLAY_COLUMN = function (onClick, entity, settings) {
    return renderListIconButtonColumn("/icons/platform/play.svg", "play", onClick, entity, settings);
};
export var DEFAULT_LIST_EDIT_COLUMN = function (onClick, entity, settings) {
    return renderListIconButtonColumn("/icons/platform/pencil.svg", "edit", onClick, entity, settings);
};
export var DEFAULT_LIST_OPEN_IN_BROWSER_COLUMN = function (onClick, entity, settings) {
    return renderListIconButtonColumn("/icons/platform/open-in-browser.svg", "open-in-browser", onClick, entity, settings);
};
export var DEFAULT_LIST_EMAIL_COLUMN = function (onClick, entity, settings) {
    return renderListIconButtonColumn("/icons/platform/send-email.svg", "email", onClick, entity, settings);
};
export var DEFAULT_LIST_ACTION_COLUMN = function (onClick, entity, settings) {
    var currentSettings = settings ? settings : {};
    var deleteConfirmationType = (entity === null || entity === void 0 ? void 0 : entity.deleteConfirmationType)
        ? entity === null || entity === void 0 ? void 0 : entity.deleteConfirmationType
        : "danger";
    var deleteConfirmationTitle = (entity === null || entity === void 0 ? void 0 : entity.deleteConfirmationTitle)
        ? entity === null || entity === void 0 ? void 0 : entity.deleteConfirmationTitle
        : "Are you sure you want to delete the ".concat(entity === null || entity === void 0 ? void 0 : entity.uiName, "?");
    var deleteButtonTitle = (entity === null || entity === void 0 ? void 0 : entity.deleteButtonLabel)
        ? entity === null || entity === void 0 ? void 0 : entity.deleteButtonLabel
        : "Delete";
    var cloneButtonTitle = (entity === null || entity === void 0 ? void 0 : entity.deleteButtonLabel)
        ? entity === null || entity === void 0 ? void 0 : entity.deleteButtonLabel
        : "Clone";
    var menuItems = (settings === null || settings === void 0 ? void 0 : settings.menuItems) ? entity === null || entity === void 0 ? void 0 : entity.menuItems : [];
    return renderListActionButtonColumn(without(__spreadArray([
        (entity === null || entity === void 0 ? void 0 : entity.disableDelete)
            ? null
            : {
                title: deleteButtonTitle,
                action: "delete",
                confirmationType: deleteConfirmationType,
                confirmationTitle: deleteConfirmationTitle
            },
        (entity === null || entity === void 0 ? void 0 : entity.disableClone)
            ? null
            : {
                title: cloneButtonTitle,
                action: "clone"
            }
    ], menuItems, true), null), onClick, entity, __assign(__assign({}, currentSettings), { onRenderWrapperClassName: settings === null || settings === void 0 ? void 0 : settings.onRenderWrapperClassName, onRenderWrapperStyle: settings === null || settings === void 0 ? void 0 : settings.onRenderWrapperStyle, onRenderIconClassName: settings === null || settings === void 0 ? void 0 : settings.onRenderIconClassName, onRenderIconColor: settings === null || settings === void 0 ? void 0 : settings.onRenderIconColor, tooltip: settings === null || settings === void 0 ? void 0 : settings.tooltip }));
};
export var renderListDefaultColumn = function (record, entity, settings) {
    var _a, _b, _c, _d, _e, _f;
    if (record.id == ((_b = (_a = settings === null || settings === void 0 ? void 0 : settings.recordInAction) === null || _a === void 0 ? void 0 : _a.record) === null || _b === void 0 ? void 0 : _b.id))
        return null;
    var colorName = getPrimaryColor().name;
    //Handle Text by using entity.displayFields
    var text = ((_c = record.highlight) === null || _c === void 0 ? void 0 : _c.searchDisplay)
        ? (_d = record.highlight) === null || _d === void 0 ? void 0 : _d.searchDisplay
        : getRecordDisplay(record, { entity: entity });
    var searchDetail = ((_e = record.highlight) === null || _e === void 0 ? void 0 : _e.searchContent)
        ? (_f = record.highlight) === null || _f === void 0 ? void 0 : _f.searchContent
        : [];
    var tags = record.tags ? record.tags : [];
    return (React.createElement("div", { className: "w-full h-full flex items-center p-4 ".concat((settings === null || settings === void 0 ? void 0 : settings.onClick) ? "cursor-pointer" : "", " "), onClick: function () {
            if (settings === null || settings === void 0 ? void 0 : settings.onClick) {
                settings === null || settings === void 0 ? void 0 : settings.onClick(record, (settings === null || settings === void 0 ? void 0 : settings.actionName) ? settings === null || settings === void 0 ? void 0 : settings.actionName : "display");
            }
        } },
        React.createElement("div", { className: "w-full flex flex-col" },
            (settings === null || settings === void 0 ? void 0 : settings.renderTopContent) &&
                (settings === null || settings === void 0 ? void 0 : settings.renderTopContent(record, entity, settings)),
            (settings === null || settings === void 0 ? void 0 : settings.renderMainContent) ? (settings === null || settings === void 0 ? void 0 : settings.renderMainContent(record, entity, settings)) : (React.createElement(React.Fragment, null,
                React.createElement("div", { className: "text-sm leading-tight font-medium text-gray-900 line-clamp-".concat(searchDetail.length > 0 ? 2 : 3), dangerouslySetInnerHTML: {
                        __html: isNonEmptyString(text)
                            ? text
                            : getRecordDisplay(record)
                    } }),
                searchDetail.length > 0 && (React.createElement("div", { className: "mt-2 text-xs font-normal leading-tight text-gray-700 line-clamp-2", dangerouslySetInnerHTML: {
                        __html: searchDetail[0]
                    } })),
                (settings === null || settings === void 0 ? void 0 : settings.showTags) && tags.length > 0 && (React.createElement(Tags, { data: tags, tooltipColorName: colorName, onClick: settings === null || settings === void 0 ? void 0 : settings.onClickTag, textClassName: "font-normal hover:font-medium text-xs", tagClassName: "py-0 mr-2 mt-2 mb-0 hover:bg-".concat(colorName, "-50 flex rounded border-gray-100 hover:border-").concat(colorName, "-100 items-center shadow"), disableShorten: true })))),
            (settings === null || settings === void 0 ? void 0 : settings.renderBottomContent) &&
                (settings === null || settings === void 0 ? void 0 : settings.renderBottomContent(record, entity, settings)))));
};
export var renderListRecordInAction = function (record, entity, settings) {
    var _a, _b;
    doNothing(entity);
    var colorName = (_a = settings === null || settings === void 0 ? void 0 : settings.colorName) !== null && _a !== void 0 ? _a : getPrimaryColor().name;
    var recordInAction = settings === null || settings === void 0 ? void 0 : settings.recordInAction;
    if (record.id != ((_b = recordInAction === null || recordInAction === void 0 ? void 0 : recordInAction.record) === null || _b === void 0 ? void 0 : _b.id))
        return null;
    var color = (recordInAction === null || recordInAction === void 0 ? void 0 : recordInAction.color)
        ? recordInAction === null || recordInAction === void 0 ? void 0 : recordInAction.color
        : getColor(colorName, 600);
    return (React.createElement("div", { className: "w-full flex flex-row items-center p-4" },
        (recordInAction === null || recordInAction === void 0 ? void 0 : recordInAction.doing) && (React.createElement(SVG, { src: "/icons/platform/loading.svg", className: "spinner", style: { width: 20, height: 20 }, color: color })),
        React.createElement("span", { className: "".concat((recordInAction === null || recordInAction === void 0 ? void 0 : recordInAction.doing) ? "pl-2 text-sm" : ""), style: { color: color } }, recordInAction === null || recordInAction === void 0 ? void 0 : recordInAction.actionMessage)));
};
export var DEFAULT_LIST_COLUMNS = function (onClickRecord, entity, settings, columnSettings) {
    var _a, _b, _c, _d;
    var cols = [
        getDefaultFirstBodyCell(onClickRecord, entity, __assign(__assign({}, settings), columnSettings === null || columnSettings === void 0 ? void 0 : columnSettings.default))
    ];
    if ((entity === null || entity === void 0 ? void 0 : entity.enablePlay) || ((_a = columnSettings === null || columnSettings === void 0 ? void 0 : columnSettings.play) === null || _a === void 0 ? void 0 : _a.enable)) {
        cols.push(DEFAULT_LIST_PLAY_COLUMN(onClickRecord, entity, __assign(__assign({}, settings), columnSettings === null || columnSettings === void 0 ? void 0 : columnSettings.play)));
    }
    if (!(entity === null || entity === void 0 ? void 0 : entity.disableEdit) && !((_b = columnSettings === null || columnSettings === void 0 ? void 0 : columnSettings.edit) === null || _b === void 0 ? void 0 : _b.disable)) {
        cols.push(DEFAULT_LIST_EDIT_COLUMN(onClickRecord, entity, __assign(__assign({}, settings), columnSettings === null || columnSettings === void 0 ? void 0 : columnSettings.edit)));
    }
    if ((!(entity === null || entity === void 0 ? void 0 : entity.disableDelete) && !((_c = columnSettings === null || columnSettings === void 0 ? void 0 : columnSettings.action) === null || _c === void 0 ? void 0 : _c.disableDelete)) ||
        (!(entity === null || entity === void 0 ? void 0 : entity.disableClone) && !((_d = columnSettings === null || columnSettings === void 0 ? void 0 : columnSettings.action) === null || _d === void 0 ? void 0 : _d.disableClone))) {
        cols.push(DEFAULT_LIST_ACTION_COLUMN(onClickRecord, entity, __assign(__assign({}, settings), columnSettings === null || columnSettings === void 0 ? void 0 : columnSettings.action)));
    }
    return cols;
};
//# sourceMappingURL=util.js.map